﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace db
{
    [DataContract]
    [Serializable]
    public class SystemInstance
    {
        [Key]
        [DataMember]
        public int Id { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataMember]
        public string Name { get; set; }

        [DataMember]
        public DateTime Date { get; set; }

        [DataMember]
        public decimal Number { get; set; }

        [DataMember]
        public SomeComplex SomeComplex { get; set; }

        [DataMember]
        public IEnumerable<SomeComplex> SomeValues { get; set; }

        [DataMember]
        public AnotherComplex AnotherComplex { get; set; }

        [DataMember]
        public IEnumerable<InstallLinks> Links { get; set; } = new List<InstallLinks>();
    }


    [DataContract]
    [Serializable]
    public class InstallLinks
    {
        [Key]
        [DataMember]
        public int Id { get; set; }

        [Required(AllowEmptyStrings = false)]
        [DataMember]
        public string Name { get; set; }

        public virtual ICollection<SystemInstance> Systems { get; set; }
    }


    [DataContract]
    public class SomeComplex
    {
        [DataMember]
        public int Id { get; set; }
        [DataMember]
        public string Name { get; set; }
    }

    [DataContract]
    public class AnotherComplex
    {
        [DataMember]
        public int Id { get; set; }
        [DataMember]
        public string Name { get; set; }
    }
}
